using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;

using Pencil.Gaming;
using Pencil.Gaming.Audio;
using Pencil.Gaming.Graphics;
using Pencil.Gaming.MathUtils;
using Pencil.Gaming.Scripting;

namespace LudumDare26 {
	public class Block {
		private Wall wall0;
		private Wall wall1;
		private Wall wall2;
		private Wall wall3;
		private Program program;
		public int X { get; private set; }
		public int Z { get; private set; }

		public Block(Program p, int x, int z) {
			wall0 = new Wall(p, x, z, true);
			wall1 = new Wall(p, x, z + 1, true);
			wall2 = new Wall(p, x + 1, z, false);
			wall3 = new Wall(p, x, z, false);

			program = p;
			this.X = x;
			this.Z = z;
		}

		public void Draw() {
			wall0.Draw();
			wall1.Draw();
			wall2.Draw();
			wall3.Draw();
		}

		public bool CollidesWith(Vector2 delta) {
			return new Rectangle(X - .1f, Z - .1f, 1.2f, 1.2f).IsVectorEnclosedBy(program.PlayerPosition + delta);
		}
	}
}

