using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.IO;

using Pencil.Gaming;
using Pencil.Gaming.Audio;
using Pencil.Gaming.Graphics;
using Pencil.Gaming.MathUtils;
using Pencil.Gaming.Scripting;

namespace LudumDare26 {
	public class HealthPack : BillBoardedSprite {
		private readonly Program program;
		public bool ShouldBeRemoved { get; private set; }

		public HealthPack(Program prgrm, float x, float z) : base(prgrm, x, 0f, z, .3f, .3f, 7, 7) {
			program = prgrm;
			Clear(0xFF888888);
			for (int xy = 0; xy < Width; ++xy) {
				SetPixel(xy, 0, 0xFF000000);
				SetPixel(xy, Height - 1, 0xFF000000);
				SetPixel(0, xy, 0xFF000000);
				SetPixel(Width - 1, xy, 0xFF000000);
			}

			SetPixel(3, 3, 0xFFFF0000);
			SetPixel(2, 3, 0xFFFF0000);
			SetPixel(3, 2, 0xFFFF0000);
			SetPixel(4, 3, 0xFFFF0000);
			SetPixel(3, 4, 0xFFFF0000);
		}

		private float totalTime = 0f;
		public void Update(float time) {
			totalTime += time;

			Y = (float)Math.Cos(totalTime);

			float deltaX = program.PlayerX + X;
			float deltaZ = program.PlayerZ - Z;

			if (deltaX * deltaX + deltaZ * deltaZ < .5f) {
				ShouldBeRemoved = true;
				if (program.PlayerHealth < 1f) {
					program.HealthPack.Play();

					program.PlayerHealth += .2f;
					program.PlayerHealth = Math.Min(program.PlayerHealth, 1f);
				}
			}
		}
	}
}

